/*
 * GUI.java
 *
 * Created on April 21
 */

import java.awt.*;
import java.awt.geom.*;
import java.util.Random;
import javax.swing.*;

/**
 * @author  wpitafi
 */
public class GUI extends javax.swing.JFrame {
    
    /** Creates new form GUI */
    public GUI() {
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        pnlProgram = new javax.swing.JPanel();
        ddlShape = new javax.swing.JComboBox();
        jButton1 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Shapes Painter");
        setName("frame2");
        jTextArea1.setBackground(new java.awt.Color(204, 204, 204));
        jTextArea1.setColumns(20);
        jTextArea1.setEditable(false);
        jTextArea1.setFont(new java.awt.Font("Courier", 1, 13));
        jTextArea1.setForeground(new java.awt.Color(0, 0, 102));
        jTextArea1.setLineWrap(true);
        jTextArea1.setRows(5);
        jTextArea1.setText("Write a program that allows the user to select a shape from a JComboBox and that then draws that shape 20 times with random locations and dimensions in method paint().  The first item in the JComboBox should be the default shape that is displayed the first time paint() is called.");
        jTextArea1.setWrapStyleWord(true);
        jScrollPane1.setViewportView(jTextArea1);

        pnlProgram.setBackground(new java.awt.Color(204, 204, 255));
        org.jdesktop.layout.GroupLayout pnlProgramLayout = new org.jdesktop.layout.GroupLayout(pnlProgram);
        pnlProgram.setLayout(pnlProgramLayout);
        pnlProgramLayout.setHorizontalGroup(
            pnlProgramLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 527, Short.MAX_VALUE)
        );
        pnlProgramLayout.setVerticalGroup(
            pnlProgramLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 265, Short.MAX_VALUE)
        );

        ddlShape.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Square", "Circle" }));
        ddlShape.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ddlShapeActionPerformed(evt);
            }
        });

        jButton1.setText("Paint");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 591, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(ddlShape, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jButton1))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(pnlProgram, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(ddlShape, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jButton1))
                    .add(pnlProgram, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        paint();
    }//GEN-LAST:event_jButton1ActionPerformed
    
    /**
     * Action Performed event handler for Convert button
     */
    private void ddlShapeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ddlShapeActionPerformed
        paint();
    }//GEN-LAST:event_ddlShapeActionPerformed
    
    /**
     * Paint method to draw the shapes
     */
    public void paint(){
        // clear any existing shapes
        pnlProgram.paintAll(pnlProgram.getGraphics());
        
        // getting graphics handle of the region to paint the shapes
        Graphics2D g2d = (Graphics2D)pnlProgram.getGraphics();
        
        int x, y;
        String shape = (String)ddlShape.getSelectedItem();
        if (shape == "Square") {
            // paint Squares
            for (int i = 0; i < 20; i++){
                x = getRandomX();
                y = getRandomY();
                Rectangle2D.Double square = new Rectangle2D.Double(
                        x, y,
                        getRandomW(x),
                        getRandomH(y));
                g2d.draw(square);
            }
        } else if (shape == "Circle") {
            // paint Ovals
            for (int i = 0; i < 20; i++){
                x = getRandomX();
                y = getRandomY();
                Ellipse2D.Double square = new Ellipse2D.Double(
                        x, y,
                        getRandomW(x),
                        getRandomH(y));
                g2d.draw(square);
            }
        }
    }
    
    /*
     * @return random value for x-coord of the shape that is not more than width of drawing panel
     */
    private int getRandomX() {
        return getRandom(pnlProgram.getWidth());
    }
    
    /*
     * @return random value for y-coord of the shape that is not more than height of drawing panel
     */
    private int getRandomY() {
        return getRandom(pnlProgram.getHeight());
    }
    
    /*
     * @return random value for width of shape that should be less than width of drawing panel - x-coord of shape
     */
    private int getRandomW(int x) {
        return getRandom(pnlProgram.getWidth() - x);
    }
    
    /*
     * @return random value for height of shape that should be less than height of drawing panel - y-coord of shape
     */
    private int getRandomH(int y) {
        return getRandom(pnlProgram.getHeight() - y);
    }
    
    /*
     * @return random value which should be below the limit specified
     */
    private int getRandom(int upperLimit) {
        Random r = new Random();
        
        int value = Math.abs(r.nextInt());
        
        if (value > upperLimit) {
            value = value % upperLimit;
        }
        
        return value;
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new GUI().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox ddlShape;
    private javax.swing.JButton jButton1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JPanel pnlProgram;
    // End of variables declaration//GEN-END:variables
    
}
